<?php
Rhaco::import("database.data.TableObjectBase");
Rhaco::import("database.data.Column");
Rhaco::import("database.data.Table");
Rhaco::import("database.data.Criteria");
Rhaco::import("lang.StringUtil");

Rhaco::import("lang.DateUtil");
Rhaco::importLibrary("data.verify.FeedVerify");
Rhaco::importLibrary("data.PageFeed");
Rhaco::importLibrary("data.Item");
class FeedTable extends TableObjectBase{
	var $id;
	var $url;
	var $updateDate;

	function FeedTable(
		$id=null
	){
		$this->id = 0;
		$this->url = null;
		$this->updateDate = null;
		$this->setId($id);
	}

	function setId($value){
		$this->id = sprintf("%d",StringUtil::convertZenhan($value));
	}
	function getId(){
		return $this->id;
	}
	function setUrl($value){
		$this->url = $value;
	}
	function getUrl(){
		return $this->url;
	}
	function setUpdateDate($value){
		if(!is_numeric($value)){
			$value = DateUtil::parseString(StringUtil::convertZenhan($value));
		}
		$this->updateDate = $value;
	}
	function getUpdateDate(){
		return $this->updateDate;
	}
	function formatUpdateDate($format="Y/m/d H:i:s"){
		return date($format,$this->updateDate);
	}
	
	function columnId(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."FEED","FEED"),"ID","Id","SERIAL");
	}
	function columnUrl(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."FEED","FEED"),"URL","Url","STRING");
	}
	function columnUpdateDate(){
		return new Column(new Table(Rhaco::define("DATABASE_goesby_PREFIX")."FEED","FEED"),"UPDATE_DATE","UpdateDate","TIMESTAMP");
	}

	function __columns(){
		return array(
				$this->columnId()
				,$this->columnUrl()
				,$this->columnUpdateDate()
				);
	}
	function __primaryKey(){
		return array(	
				$this->columnId()
				);
	}
	function dependColumnId(){
		$list	= array();
	
		$criteria = new Criteria();
		$criteria->add(PageFeed::columnFeedId(),$this->getId());
		$list[] = array(new PageFeed(),$criteria);
	
		$criteria = new Criteria();
		$criteria->add(Item::columnFeedId(),$this->getId());
		$list[] = array(new Item(),$criteria);
		
		return $list;
	}
	function related($criteria=null){
		if(!preg_match("/Criteria/i",get_class($criteria))){		
			$criteria = new Criteria();
		}
		
		return $criteria;
	}
	function __verify(){
		$verify = new FeedVerify();
		return $verify->verify($this);
	}
}
?>